package com.liang.service;

import com.liang.entity.PrjProject;
import com.liang.entity.StaFeasibilityreport;
import com.liang.entity.SysPostInfo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * (StaFeasibilityreport)表服务接口
 *
 * @author makejava
 * @since 2023-03-03 23:38:24
 */
public interface StaFeasibilityreportService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaFeasibilityreport queryById(Integer id);

    /**
     * 分页查询
     *
     * @param staFeasibilityreport 筛选条件
     * @param pageRequest          分页对象
     * @return 查询结果
     */
    Page<StaFeasibilityreport> queryByPage(StaFeasibilityreport staFeasibilityreport, PageRequest pageRequest);

    /**
     * 新增数据（基本信息）
     *
     * @param staFeasibilityreport 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(StaFeasibilityreport staFeasibilityreport);

    /**
     * 新增数据
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int insert(StaFeasibilityreport staFeasibilityreport);

    /**
     * 新增数据(基本数据)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int insertNormal(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    StaFeasibilityreport update(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(基本信息)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateNormal(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(目的和意义)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateMdhyy(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(研究水平)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateYjsp(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(理论实践依据)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateLlsjyj(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(研究内容)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateYjnr(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(经济性财务合规性)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateJjxcwhgx(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(预期目标)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateYqmb(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(合作单位)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateHzdw(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(承担单位条件)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateCddw(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(审查意见)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateScyj(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(附件)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateFj(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(签名盖章)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateQmgz(StaFeasibilityreport staFeasibilityreport);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 数据分页查询
     *
     * @param map
     * @return
     */
    List<StaFeasibilityreport> getReportInfoList(Map map);

    /**
     * 根据项目类型获取科研报告
     *
     * @param map
     * @return
     */
    List<StaFeasibilityreport> getRwsKybgList(Map map);

    /**
     * 修改审批状态
     *
     * @param project
     * @return
     */
    int updateSpzt(StaFeasibilityreport project);
}
